//+------------------------------------------------------------------+
//|                                              PositionManager.mq4 |
//|                                                            Verdi |
//|                                                  nemo811@mail.ru |
//+------------------------------------------------------------------+

/*
   . 
:   -    .
:
 -   (ProfitPoint,  );
 -   (LossPoint,  ). 
 ,     ( Buy,  Sell),  ,    .
    Buy,  Sell -     (  ).
        market-       .
*/

#property copyright "Verdi"
#property link      "nemo811@mail.ru"

extern int ProfitPoint = 12; //   , ;  0 - .
                             //   ProfitPoint       
extern int LossPoint   = 15; //   market-,    , .;  0 - .
                             //    LossPoint -           

string Comm1,Comm2; 

int init()
  {
   if (!IsTesting())
    {
     if(!IsExpertEnabled())
      {
       Alert("   !");
       Comment("   !");
       return(0);
      }
     else
      {
       Comment("  .   .");
       Print("  .   .");
      }
    }
   return(0);
  }

int deinit()
  {
   if (!IsTesting())
    {
     Print("  ().");
    }
   return(0);
  }

int start()
  {

   if(!IsTradeAllowed())
    {
     Comment("    ,    .");
     return(0);
    }

   RefreshRates();

   if(ProfitPoint>0)
    { 
     CloseTicketProfit_b();
    }

   double SchBuyLots=NormalizeDouble(SchBuyLots_b(),8);
   double SchSellLots=NormalizeDouble(SchSellLots_b(),8);
   double Zero=NormalizeDouble(0,8);   

   if(LossPoint>0)
    { 
     double FirstBuyOpenPrice=FirstBuyOpenPrice_b();
     double FirstSellOpenPrice=FirstSellOpenPrice_b();
     if (SchBuyLots>Zero && SchSellLots==Zero && FirstBuyOpenPrice-NormalizeDouble(LossPoint*Point,Digits)>=Ask)   
      {
       DeleteOtlozh();
       OPENORDER ("Sell");
      }
 
     if (SchBuyLots==Zero && SchSellLots>Zero && FirstSellOpenPrice+NormalizeDouble(LossPoint*Point,Digits)<=Bid)   
      {
       DeleteOtlozh();
       OPENORDER ("Buy");
      }
    }

   if (SchBuyLots>Zero && SchSellLots>Zero)
    {
     if (SchBuyLots!=SchSellLots)
      {
       Comment("  \n   !");
      }
     else
      {
       Comment(" LOCK");
      }
    }
   else
    {
     if (ProfitPoint>0)
      { 
       Comm1=StringConcatenate(DoubleToStr(ProfitPoint,0)," .");
      }
     else
      {
       Comm1=".";
      }

     if (LossPoint>0)
      { 
       Comm2=StringConcatenate(DoubleToStr(LossPoint,0)," .");
      }
     else
      {
       Comm2=".";
      }

     Comment("ProfitPoint - ",Comm1,
             "\nLossPoint - ",Comm2,
             "\nwww.mt4.ucoz.com");

    }
     
   return(0);
  }
//+------------------------------------------------------------------+

double SchBuyLots_b()
 {
  double SchBuyLots=0;
  int i;
  string SMB=Symbol();
  for (i=OrdersTotal()-1;i>=0;i--)
   {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
     {
      Alert (" ",GetLastError(),"  !");
      Print (" ",GetLastError(),"  !");
     }
    else
     {
      if(OrderSymbol()==SMB && OrderType()==OP_BUY)
       {
        SchBuyLots=SchBuyLots+OrderLots();
       }
     }
   }
  return(SchBuyLots);
 }

double SchSellLots_b()
 {
  double SchSellLots=0;
  int i;
  string SMB=Symbol();
  for (i=OrdersTotal()-1;i>=0;i--)
   {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
     {
      Alert (" ",GetLastError(),"  !");
      Print (" ",GetLastError(),"  !");
     }
    else
     {
      if(OrderSymbol()==SMB && OrderType()==OP_SELL)
       {
        SchSellLots=SchSellLots+OrderLots();
       }
     }
   }
  return(SchSellLots);
 }

int TicketProfit_b(int ProfitPoint)
 {
  int i;
  int TicketProfit=0;
  double OpenPrice=0;
  string SMB=Symbol();

  double SchBuyLots=NormalizeDouble(SchBuyLots_b(),8);
  double SchSellLots=NormalizeDouble(SchSellLots_b(),8);
  double Zero=NormalizeDouble(0,8);

  for(i=OrdersTotal()-1;i>=0;i--)
   {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
     {
      Alert (" ",GetLastError(),"  !");
      Print (" ",GetLastError(),"  !");
     }
    else
     {
      if(OrderSymbol()==SMB)
       {
        if (SchBuyLots>Zero && SchSellLots>Zero)
         {
          TicketProfit=0;
         } 
        else
         {
          if(OrderType()==OP_BUY)
           {
            OpenPrice=OrderOpenPrice();
            if (OpenPrice+NormalizeDouble(ProfitPoint*Point,Digits)<=Bid) TicketProfit=OrderTicket();
           }  
          if(OrderType()==OP_SELL)
           {
            OpenPrice=OrderOpenPrice();
            if (OpenPrice-NormalizeDouble(ProfitPoint*Point,Digits)>=Ask) TicketProfit=OrderTicket();
           } 
         }  
       }          
     }
   }
  return(TicketProfit);
 }

double FirstBuyOpenPrice_b()
 {
  int i;
  double FirstBuyOpenPrice=0;
  string SMB=Symbol();   
  for (i=OrdersTotal()-1;i>=0;i--)
   {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
     {
      Alert (" ",GetLastError(),"  !");
      Print (" ",GetLastError(),"  !");
     }
    else
     {
      if(OrderSymbol()==SMB && OrderType()==OP_BUY)
       { 
        FirstBuyOpenPrice=OrderOpenPrice();
       }
     }
   }
  return(FirstBuyOpenPrice);
 }

double FirstSellOpenPrice_b()
 {
  int i;
  double FirstSellOpenPrice=0;
  string SMB=Symbol();   
  for (i=OrdersTotal()-1;i>=0;i--)
   {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
     {
      Alert (" ",GetLastError(),"  !");
      Print (" ",GetLastError(),"  !");
     }
    else
     {
      if(OrderSymbol()==SMB && OrderType()==OP_SELL)
       { 
        FirstSellOpenPrice=OrderOpenPrice();
       }
     }
   }
  return(FirstSellOpenPrice);
 }
 
void OPENORDER(string ord)
 {
  int ticket = -1;

  double Lot;
  double SchBuyLots  = SchBuyLots_b();
  double SchSellLots = SchSellLots_b();

  Lot=MathAbs(SchBuyLots-SchSellLots);

  while (ticket<0)
   {
    if (ord=="Buy")  ticket=OrderSend(Symbol(),OP_BUY, Lot,Ask,3,0,0," ",0,0);
    if (ord=="Sell") ticket=OrderSend(Symbol(),OP_SELL,Lot,Bid,3,0,0," ",0,0);
    if (ticket==-1)
     {  
      Alert (" ",GetLastError(),"   !");
      Print (" ",GetLastError(),"   !");
     }
    else
     {   
      Alert ("   LossPoint ",LossPoint," .\nwww.mt4.ucoz.com");
      Print ("   LossPoint ",LossPoint," .");
      return (0);
     }
   }
  return;
 } 

void DeleteOtlozh()
 {
  int i;
  string SMB=Symbol();
  for (i=OrdersTotal()-1;i>=0;i--) 
   {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
     {
      Alert (" ",GetLastError(),"  !");
      Print (" ",GetLastError(),"  !");
     }
    else
     {
      if(OrderSymbol()==SMB)
       { 
        if(OrderType()==OP_BUYLIMIT || OrderType()==OP_SELLLIMIT || OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP)
         {
          if(!OrderDelete(OrderTicket(),CLR_NONE))
           {
            Alert(" ",GetLastError(),"      ",OrderTicket(),"   ",Symbol());
           }
         }  
       } 
     }       
   }
 }

void CloseTicketProfit_b()
 { 
  int i;
  string SMB=Symbol();

  int TicketProfit=TicketProfit_b(ProfitPoint);

  if (TicketProfit<=0) return;

  for (i=OrdersTotal()-1;i>=0;i--)
   {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
     {
      Alert (" ",GetLastError(),"  !");
      Print (" ",GetLastError(),"  !");
     }
    else
     {
      if(OrderSymbol()==SMB) 
       { 
        if(OrderType()==OP_BUY && OrderTicket()==TicketProfit)
         {
          if(!OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_BID),3,CLR_NONE))
           {
            Alert(" ",GetLastError(),"   Buy-  ",OrderTicket(),"   ",Symbol());
            Print(" ",GetLastError(),"   Buy-  ",OrderTicket(),"   ",Symbol());
           }
          else
           {   
            Alert("   ProfitPoint ",ProfitPoint," .\nwww.mt4.ucoz.com");
            Print("   ProfitPoint ",ProfitPoint," .");
           }
         }  
        if(OrderType()==OP_SELL && OrderTicket()==TicketProfit)
         {
          if(!OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_ASK),3,CLR_NONE))
           {
            Alert(" ",GetLastError(),"   Sell-  ",OrderTicket(),"   ",Symbol());
            Print(" ",GetLastError(),"   Sell-  ",OrderTicket(),"   ",Symbol());
           }
          else
           {   
            Alert("   ProfitPoint ",ProfitPoint," .\nwww.mt4.ucoz.com");
            Print("   ProfitPoint ",ProfitPoint," .");
           }
         }
       }  
     }
   }
  DeleteOtlozh();
 }

//+------------------------------------------------------------------+

